<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>TestRequestClientConnControl xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../testapidocs/org/apache/http/client/protocol/TestRequestClientConnControl.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> *  Licensed to the Apache Software Foundation (ASF) under one or more</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> *  contributor license agreements.  See the NOTICE file distributed with</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> *  this work for additional information regarding copyright ownership.</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> *  The ASF licenses this file to You under the Apache License, Version 2.0</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> *  (the "License"); you may not use this file except in compliance with</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> *  the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *      <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> *  Unless required by applicable law or agreed to in writing, software</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> *  distributed under the License is distributed on an "AS IS" BASIS,</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> *  See the License for the specific language governing permissions and</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> *  limitations under the License.</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  
<a class="jxr_linenumber" name="27" href="#27">27</a>  <strong class="jxr_keyword">package</strong> org.apache.http.client.protocol;
<a class="jxr_linenumber" name="28" href="#28">28</a>  
<a class="jxr_linenumber" name="29" href="#29">29</a>  <strong class="jxr_keyword">import</strong> junit.framework.Assert;
<a class="jxr_linenumber" name="30" href="#30">30</a>  
<a class="jxr_linenumber" name="31" href="#31">31</a>  <strong class="jxr_keyword">import</strong> org.apache.http.Header;
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpHost;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequestInterceptor;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.HttpRoutedConnection;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.HttpRoute;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.LayerType;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.conn.routing.RouteInfo.TunnelType;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.message.BasicHttpRequest;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.BasicHttpContext;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.ExecutionContext;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HTTP;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpContext;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.junit.Test;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.mockito.Mockito;
<a class="jxr_linenumber" name="46" href="#46">46</a>  
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/client/protocol/TestRequestClientConnControl.html">TestRequestClientConnControl</a> {
<a class="jxr_linenumber" name="48" href="#48">48</a>  
<a class="jxr_linenumber" name="49" href="#49">49</a>      @Test(expected=IllegalArgumentException.<strong class="jxr_keyword">class</strong>)
<a class="jxr_linenumber" name="50" href="#50">50</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testRequestParameterCheck() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="51" href="#51">51</a>          HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="52" href="#52">52</a>          HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="53" href="#53">53</a>          interceptor.process(<strong class="jxr_keyword">null</strong>, context);
<a class="jxr_linenumber" name="54" href="#54">54</a>      }
<a class="jxr_linenumber" name="55" href="#55">55</a>  
<a class="jxr_linenumber" name="56" href="#56">56</a>      @Test
<a class="jxr_linenumber" name="57" href="#57">57</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testConnectionKeepAliveForConnectRequest() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="58" href="#58">58</a>          HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"CONNECT"</span>, <span class="jxr_string">"www.somedomain.com"</span>);
<a class="jxr_linenumber" name="59" href="#59">59</a>          HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="60" href="#60">60</a>  
<a class="jxr_linenumber" name="61" href="#61">61</a>          HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="62" href="#62">62</a>          interceptor.process(request, context);
<a class="jxr_linenumber" name="63" href="#63">63</a>          Header header1 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="64" href="#64">64</a>          Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="65" href="#65">65</a>          Assert.assertEquals(HTTP.CONN_KEEP_ALIVE, header1.getValue());
<a class="jxr_linenumber" name="66" href="#66">66</a>          Header header2 = request.getFirstHeader(HTTP.CONN_DIRECTIVE);
<a class="jxr_linenumber" name="67" href="#67">67</a>          Assert.assertNull(header2);
<a class="jxr_linenumber" name="68" href="#68">68</a>      }
<a class="jxr_linenumber" name="69" href="#69">69</a>  
<a class="jxr_linenumber" name="70" href="#70">70</a>      @Test
<a class="jxr_linenumber" name="71" href="#71">71</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testConnectionKeepAliveForDirectRequests() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="72" href="#72">72</a>          HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="73" href="#73">73</a>          HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="74" href="#74">74</a>  
<a class="jxr_linenumber" name="75" href="#75">75</a>          HttpHost target = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80, <span class="jxr_string">"http"</span>);
<a class="jxr_linenumber" name="76" href="#76">76</a>          HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(target, <strong class="jxr_keyword">null</strong>, false);
<a class="jxr_linenumber" name="77" href="#77">77</a>  
<a class="jxr_linenumber" name="78" href="#78">78</a>          HttpRoutedConnection conn = Mockito.mock(HttpRoutedConnection.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="79" href="#79">79</a>          Mockito.when(conn.getRoute()).thenReturn(route);
<a class="jxr_linenumber" name="80" href="#80">80</a>  
<a class="jxr_linenumber" name="81" href="#81">81</a>          context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="82" href="#82">82</a>  
<a class="jxr_linenumber" name="83" href="#83">83</a>          HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="84" href="#84">84</a>          interceptor.process(request, context);
<a class="jxr_linenumber" name="85" href="#85">85</a>  
<a class="jxr_linenumber" name="86" href="#86">86</a>          Header header1 = request.getFirstHeader(HTTP.CONN_DIRECTIVE);
<a class="jxr_linenumber" name="87" href="#87">87</a>          Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="88" href="#88">88</a>          Assert.assertEquals(HTTP.CONN_KEEP_ALIVE, header1.getValue());
<a class="jxr_linenumber" name="89" href="#89">89</a>          Header header2 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="90" href="#90">90</a>          Assert.assertNull(header2);
<a class="jxr_linenumber" name="91" href="#91">91</a>      }
<a class="jxr_linenumber" name="92" href="#92">92</a>  
<a class="jxr_linenumber" name="93" href="#93">93</a>      @Test
<a class="jxr_linenumber" name="94" href="#94">94</a>      <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testConnectionKeepAliveForTunneledRequests() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="95" href="#95">95</a>          HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="96" href="#96">96</a>          HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="97" href="#97">97</a>  
<a class="jxr_linenumber" name="98" href="#98">98</a>          HttpHost target = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 443, <span class="jxr_string">"https"</span>);
<a class="jxr_linenumber" name="99" href="#99">99</a>          HttpHost proxy = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 8080);
<a class="jxr_linenumber" name="100" href="#100">100</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(target, <strong class="jxr_keyword">null</strong>, proxy, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="101" href="#101">101</a>                 TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="102" href="#102">102</a> 
<a class="jxr_linenumber" name="103" href="#103">103</a>         HttpRoutedConnection conn = Mockito.mock(HttpRoutedConnection.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="104" href="#104">104</a>         Mockito.when(conn.getRoute()).thenReturn(route);
<a class="jxr_linenumber" name="105" href="#105">105</a> 
<a class="jxr_linenumber" name="106" href="#106">106</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="107" href="#107">107</a> 
<a class="jxr_linenumber" name="108" href="#108">108</a>         HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="109" href="#109">109</a>         interceptor.process(request, context);
<a class="jxr_linenumber" name="110" href="#110">110</a> 
<a class="jxr_linenumber" name="111" href="#111">111</a>         Header header1 = request.getFirstHeader(HTTP.CONN_DIRECTIVE);
<a class="jxr_linenumber" name="112" href="#112">112</a>         Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="113" href="#113">113</a>         Assert.assertEquals(HTTP.CONN_KEEP_ALIVE, header1.getValue());
<a class="jxr_linenumber" name="114" href="#114">114</a>         Header header2 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="115" href="#115">115</a>         Assert.assertNull(header2);
<a class="jxr_linenumber" name="116" href="#116">116</a>     }
<a class="jxr_linenumber" name="117" href="#117">117</a> 
<a class="jxr_linenumber" name="118" href="#118">118</a>     @Test
<a class="jxr_linenumber" name="119" href="#119">119</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testProxyConnectionKeepAliveForRequestsOverProxy() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="120" href="#120">120</a>         HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="121" href="#121">121</a>         HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="122" href="#122">122</a> 
<a class="jxr_linenumber" name="123" href="#123">123</a>         HttpHost target = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80, <span class="jxr_string">"http"</span>);
<a class="jxr_linenumber" name="124" href="#124">124</a>         HttpHost proxy = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 8080);
<a class="jxr_linenumber" name="125" href="#125">125</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(target, <strong class="jxr_keyword">null</strong>, proxy, false,
<a class="jxr_linenumber" name="126" href="#126">126</a>                 TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="127" href="#127">127</a> 
<a class="jxr_linenumber" name="128" href="#128">128</a>         HttpRoutedConnection conn = Mockito.mock(HttpRoutedConnection.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="129" href="#129">129</a>         Mockito.when(conn.getRoute()).thenReturn(route);
<a class="jxr_linenumber" name="130" href="#130">130</a> 
<a class="jxr_linenumber" name="131" href="#131">131</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="132" href="#132">132</a> 
<a class="jxr_linenumber" name="133" href="#133">133</a>         HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="134" href="#134">134</a>         interceptor.process(request, context);
<a class="jxr_linenumber" name="135" href="#135">135</a> 
<a class="jxr_linenumber" name="136" href="#136">136</a>         Header header1 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="137" href="#137">137</a>         Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="138" href="#138">138</a>         Assert.assertEquals(HTTP.CONN_KEEP_ALIVE, header1.getValue());
<a class="jxr_linenumber" name="139" href="#139">139</a>         Header header2 = request.getFirstHeader(HTTP.CONN_DIRECTIVE);
<a class="jxr_linenumber" name="140" href="#140">140</a>         Assert.assertNull(header2);
<a class="jxr_linenumber" name="141" href="#141">141</a>     }
<a class="jxr_linenumber" name="142" href="#142">142</a> 
<a class="jxr_linenumber" name="143" href="#143">143</a>     @Test
<a class="jxr_linenumber" name="144" href="#144">144</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPreserveCustomConnectionHeader() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="145" href="#145">145</a>         HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="146" href="#146">146</a>         request.addHeader(HTTP.CONN_DIRECTIVE, HTTP.CONN_CLOSE);
<a class="jxr_linenumber" name="147" href="#147">147</a>         HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="148" href="#148">148</a> 
<a class="jxr_linenumber" name="149" href="#149">149</a>         HttpHost target = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 443, <span class="jxr_string">"https"</span>);
<a class="jxr_linenumber" name="150" href="#150">150</a>         HttpHost proxy = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 8080);
<a class="jxr_linenumber" name="151" href="#151">151</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(target, <strong class="jxr_keyword">null</strong>, proxy, <strong class="jxr_keyword">true</strong>,
<a class="jxr_linenumber" name="152" href="#152">152</a>                 TunnelType.TUNNELLED, LayerType.LAYERED);
<a class="jxr_linenumber" name="153" href="#153">153</a> 
<a class="jxr_linenumber" name="154" href="#154">154</a>         HttpRoutedConnection conn = Mockito.mock(HttpRoutedConnection.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="155" href="#155">155</a>         Mockito.when(conn.getRoute()).thenReturn(route);
<a class="jxr_linenumber" name="156" href="#156">156</a> 
<a class="jxr_linenumber" name="157" href="#157">157</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="158" href="#158">158</a> 
<a class="jxr_linenumber" name="159" href="#159">159</a>         HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="160" href="#160">160</a>         interceptor.process(request, context);
<a class="jxr_linenumber" name="161" href="#161">161</a> 
<a class="jxr_linenumber" name="162" href="#162">162</a>         Header header1 = request.getFirstHeader(HTTP.CONN_DIRECTIVE);
<a class="jxr_linenumber" name="163" href="#163">163</a>         Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="164" href="#164">164</a>         Assert.assertEquals(HTTP.CONN_CLOSE, header1.getValue());
<a class="jxr_linenumber" name="165" href="#165">165</a>         Header header2 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="166" href="#166">166</a>         Assert.assertNull(header2);
<a class="jxr_linenumber" name="167" href="#167">167</a>     }
<a class="jxr_linenumber" name="168" href="#168">168</a> 
<a class="jxr_linenumber" name="169" href="#169">169</a>     @Test
<a class="jxr_linenumber" name="170" href="#170">170</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> testPreserveCustomProxyConnectionHeader() <strong class="jxr_keyword">throws</strong> Exception {
<a class="jxr_linenumber" name="171" href="#171">171</a>         HttpRequest request = <strong class="jxr_keyword">new</strong> BasicHttpRequest(<span class="jxr_string">"GET"</span>, <span class="jxr_string">"/"</span>);
<a class="jxr_linenumber" name="172" href="#172">172</a>         request.addHeader(<span class="jxr_string">"Proxy-Connection"</span>, HTTP.CONN_CLOSE);
<a class="jxr_linenumber" name="173" href="#173">173</a>         HttpContext context = <strong class="jxr_keyword">new</strong> BasicHttpContext();
<a class="jxr_linenumber" name="174" href="#174">174</a> 
<a class="jxr_linenumber" name="175" href="#175">175</a>         HttpHost target = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 80, <span class="jxr_string">"http"</span>);
<a class="jxr_linenumber" name="176" href="#176">176</a>         HttpHost proxy = <strong class="jxr_keyword">new</strong> HttpHost(<span class="jxr_string">"localhost"</span>, 8080);
<a class="jxr_linenumber" name="177" href="#177">177</a>         HttpRoute route = <strong class="jxr_keyword">new</strong> HttpRoute(target, <strong class="jxr_keyword">null</strong>, proxy, false,
<a class="jxr_linenumber" name="178" href="#178">178</a>                 TunnelType.PLAIN, LayerType.PLAIN);
<a class="jxr_linenumber" name="179" href="#179">179</a> 
<a class="jxr_linenumber" name="180" href="#180">180</a>         HttpRoutedConnection conn = Mockito.mock(HttpRoutedConnection.<strong class="jxr_keyword">class</strong>);
<a class="jxr_linenumber" name="181" href="#181">181</a>         Mockito.when(conn.getRoute()).thenReturn(route);
<a class="jxr_linenumber" name="182" href="#182">182</a> 
<a class="jxr_linenumber" name="183" href="#183">183</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="184" href="#184">184</a> 
<a class="jxr_linenumber" name="185" href="#185">185</a>         HttpRequestInterceptor interceptor = <strong class="jxr_keyword">new</strong> RequestClientConnControl();
<a class="jxr_linenumber" name="186" href="#186">186</a>         interceptor.process(request, context);
<a class="jxr_linenumber" name="187" href="#187">187</a> 
<a class="jxr_linenumber" name="188" href="#188">188</a>         Header header1 = request.getFirstHeader(<span class="jxr_string">"Proxy-Connection"</span>);
<a class="jxr_linenumber" name="189" href="#189">189</a>         Assert.assertNotNull(header1);
<a class="jxr_linenumber" name="190" href="#190">190</a>         Assert.assertEquals(HTTP.CONN_CLOSE, header1.getValue());
<a class="jxr_linenumber" name="191" href="#191">191</a>     }
<a class="jxr_linenumber" name="192" href="#192">192</a> 
<a class="jxr_linenumber" name="193" href="#193">193</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

